/* LightBulbLightOnEditor2.java */

import java.awt.*;
import java.beans.*;

public class LightBulbLightOnEditor2
extends PropertyEditorSupport 
{
  boolean currentvalue;

  public void setValue(Object value) 
  {
    currentvalue = ((Boolean)value).booleanValue();
  }

  public Object getValue()
  {
    return new Boolean(currentvalue);
  }

  public String getAsText() 
  {
    return "" + (currentvalue ? "an" : "aus");
  }

  public void setAsText(String text) 
  throws java.lang.IllegalArgumentException 
  {
    System.out.println("setAsText(" + text + ")");
    if (text.equalsIgnoreCase("an")) {
      currentvalue = true;
    } else if (text.equalsIgnoreCase("aus")) {
      currentvalue = false;
    } else {
      throw new IllegalArgumentException(text);
    }
    firePropertyChange();
  }

  public String[] getTags() 
  {
    return new String[]{"aus", "an"};
  }
}