/* Listing3708.java */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Listing3708
extends JFrame
implements ActionListener
{
  private ButtonGroup group = new ButtonGroup();

  public Listing3708()
  {
    super("JRadioButton");
    addWindowListener(new WindowClosingAdapter());
    //RadioButton-Panel
    JPanel panel = new JPanel();
    panel.setLayout(new GridLayout(3, 1));
    for (int i = 1; i <= 3; ++i) {
      JRadioButton rb = new JRadioButton("RadioButton" + i, i == 2);
      rb.setActionCommand(rb.getText());
      panel.add(rb);
      group.add(rb);
    }
    getContentPane().add(panel, "Center");
    //Selektion-Button
    JButton button = new JButton("Selektion");
    button.addActionListener(this);
    getContentPane().add(button, "South");
  }

  public void actionPerformed(ActionEvent event)
  {
    String cmd = event.getActionCommand();
    if (cmd.equals("Selektion")) {
      ButtonModel selected = group.getSelection();
      System.out.print("Selektiert: ");
      if (selected != null) {
        System.out.println(selected.getActionCommand());
      }
    }
  }

  public static void main(String[] args)
  {
    Listing3708 frame = new Listing3708();
    frame.setLocation(100, 100);
    frame.setSize(300, 120);
    frame.setVisible(true);
  }
}