/* Listing3709.java */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Listing3709
extends JFrame
implements ActionListener
{
  static final String[] DATA = {
    "Hund", "Katze", "Meerschweinchen", "Tiger", "Maus",
    "Fisch", "Leopard", "Schimpanse", "Kuh", "Pferd",
    "Reh", "Huhn", "Marder", "Adler", "Nilpferd"
  };

  private JList list;

  public Listing3709()
  {
    super("JList");
    addWindowListener(new WindowClosingAdapter());
    Container cp = getContentPane();
    //Liste
    list = new JList(DATA);
    list.setSelectionMode(
      ListSelectionModel.MULTIPLE_INTERVAL_SELECTION
    );
    list.setSelectedIndex(2);
    cp.add(new JScrollPane(list), "Center");
    //Ausgabe-Button
    JButton button = new JButton("Ausgabe");
    button.addActionListener(this);
    cp.add(button, "South");
  }

  public void actionPerformed(ActionEvent event)
  {
    String cmd = event.getActionCommand();
    if (cmd.equals("Ausgabe")) {
      System.out.println("---");
      ListModel lm = list.getModel();
      int[] sel = list.getSelectedIndices();
      for (int i = 0; i < sel.length; ++i) {
        String value = (String)lm.getElementAt(sel[i]);
        System.out.println("  " + value);
      }
    }
  }

  public static void main(String[] args)
  {
    Listing3709 frame = new Listing3709();
    frame.setLocation(100, 100);
    frame.setSize(200, 200);
    frame.setVisible(true);
  }
}