/* Listing3808.java */

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;

public class Listing3808
extends JFrame
implements TableData
{
  public Listing3808()
  {
    super("JTable 3");
    addWindowListener(new WindowClosingAdapter());
    //Spaltenmodell erzeugen
    DefaultTableColumnModel cm = new DefaultTableColumnModel();
    for (int i = 0; i < COLHEADS.length; ++i) {
      TableColumn col = new TableColumn(i, i == 2 ? 150 : 60);
      col.setHeaderValue(COLHEADS[i]);
      cm.addColumn(col);
    }
    //Tabellenmodell erzeugen
    TableModel tm = new AbstractTableModel() {
      public int getRowCount()
      {
        return DATA.length;
      }
      public int getColumnCount()
      {
        return DATA[0].length;
      }
      public Object getValueAt(int row, int column)
      {
        return DATA[row][column];
      }
    };
    //Tabelle erzeugen und ContentPane fllen
    JTable table = new JTable(tm, cm);
    Container cp = getContentPane();
    cp.add(new JLabel("Alte c\'t-Ausgaben:"), "North");
    cp.add(new JScrollPane(table), "Center");
  }

  public static void main(String[] args)
  {
    Listing3808 frame = new Listing3808();
    frame.setLocation(100, 100);
    frame.setSize(350, 200);
    frame.setVisible(true);
  }
}